<script lang="ts">
  import requireRole from '@auth/PermissionRequired';
  import { EventRole } from '@auth/models';
  import Env from '@env';
  import YAML from 'yaml';
  import { Gql } from '@db';
  import axios from 'axios';
  import { Input, InputGroup, InputGroupText } from '@sveltestrap/sveltestrap';
  import type { TapiEventTeam, TapiEventTeamUser } from '@models/Tapi';
  import type { Team } from '@models/Team';
  import { eventId, keycloak } from '@stores';
  import type { TeamVariables } from '@models/Variables';
  import type { EventConfiguration } from '@models/EventConfigurations';
  requireRole(EventRole.Staff);
  let tapiUrl = Env.TapiUri;

  type CombinedTeamInfo = Team & {
    tapi_name?: string;
    tapi_members?: TapiEventTeamUser[];
  };

  async function getTeamMap() {
    const gqlTeams = (
      await Gql.query<{ teams: CombinedTeamInfo[] }>(`query EventInfoTeams {
    teams {
      id
      name
      tapi_id
    }}`)
    ).teams;

    if (!tapiUrl) return gqlTeams;

    console.log(gqlTeams);

    const requests = gqlTeams.map(async (t) => {
      // Map function will return a promise that must be awaited
      // while the team object is updated in-place
      if (!t.tapi_id) return;
      try {
        const response = await axios.get<TapiEventTeam>(`${tapiUrl}/v1/events/teams/${t.tapi_id}`, {
          headers: {
            Authorization: `Bearer ${$keycloak?.token}`,
          },
        });
        t.tapi_name = response.data.name;
        t.tapi_members = response.data.eventTeamUsers;
      } catch (e) {
        console.error(e);
        return;
      }
    });

    // wait for network requests to complete for each team
    await Promise.all(requests);

    return gqlTeams;
  }

  async function getEvents() {
    const query = `query ServiceStatus {
    events {
      id
      name
      start
      end
      periods {
        start
        end
      }
    }
  }`;
    return (await Gql.query<{ events: EventConfiguration[] }>(query, { queryRole: EventRole.Staff })).events;
  }
</script>

<svelte:head><title>Event Info</title></svelte:head>

<InputGroup class="mb-3">
  <InputGroupText>TAPI URL:</InputGroupText>
  <Input class="bg-white text-dark" bind:value={tapiUrl} />
</InputGroup>

<div class="p-3">
  <h3>Environment:</h3>
  <pre>{YAML.stringify(Env)}</pre>
</div>

{#await getEvents() then events}
  <div class="p-3">
    <h3>Events:</h3>
    <pre style="white-space: pre-line">
      {YAML.stringify(events)}
    </pre>
  </div>
{/await}

<div class="p-3">
  <h3>Team Map:</h3>
  {#key tapiUrl}
    {#await getTeamMap() then teams}
      <pre style="white-space: pre-line">
      {#each teams as team}
          {team.name} -> {team.tapi_name}
        <span />
        {/each}
    </pre>
      <h3>All Team Info</h3>
      <pre>{YAML.stringify(teams)}</pre>
    {/await}
  {/key}
</div>
